#include "general.h"
#include "Display.h"

void InitSdCard()
{
  Serial.println(F("Initialising SD card..."));
  bool mysd = 0;
  // see if the card is present and can be initialized:
  while (!mysd)
  {
    if (!sd.begin(SD_CHIP_SELECT, SPI_FULL_SPEED)) {
      Serial.println(F("Card failed, or not present"));
      Serial.println(F("Retrying...."));
    }
    else
    {
      mysd = 1;
      Serial.println(F("Card initialised."));
    }
  }
}

void baueStandardBild()
{
  strcpy_P(filename, PSTR("TEST")); myFiles.load(0, 0, 800, 480, filename, 1 , 1);//Startbildschirm
  strcpy_P(filename, PSTR("Off.raw")); myFiles.load(35, 10, 217, 80, filename, 1 , 1);//Startbildschirm
  strcpy_P(filename, PSTR("1.raw")); myFiles.load(35, 105, 80, 80, filename, 1 , 1);//Startbildschirm
  strcpy_P(filename, PSTR("Dreieck.raw")); myFiles.load(35, 203, 217, 80, filename, 1 , 1);//Startbildschirm
  strcpy_P(filename, PSTR("Rechteck.raw")); myFiles.load(35, 303, 217, 80, filename, 1 , 1);//Startbildschirm
  strcpy_P(filename, PSTR("10.raw")); myFiles.load(285, 390, 80, 80, filename, 1 , 1);//Startbildschirm
  strcpy_P(filename, PSTR("0.raw")); myFiles.load(398, 390, 80, 80, filename, 1 , 1);//Startbildschirm
  strcpy_P(filename, PSTR("10Hz.raw")); myFiles.load(478, 225, 217, 80, filename, 1 , 1);//Startbildschirm
  strcpy_P(filename, PSTR("50%.raw")); myFiles.load(478, 51, 217, 80, filename, 1 , 1);//Startbildschirm
}

void refreshScreeen()
{
  if (refresh_ChangeAmplifier)
  {
    refresh_ChangeAmplifier = 0;
    if (state_ChangeAmplifier == 0)
    {
      strcpy_P(filename, PSTR("1.raw")); 
      myFiles.load(35, 105, 80, 80, filename, 1 , 1);
    }
    else
    {
      strcpy_P(filename, PSTR("2.raw")); 
      myFiles.load(35, 105, 80, 80, filename, 1 , 1);
    }
  }
  if (refresh_ChangeForm)
  {
    refresh_ChangeForm = 0;
    if (state_ChangeForm == 0)
    {
      strcpy_P(filename, PSTR("Dreieck.raw")); 
      myFiles.load(35, 203, 217, 80, filename, 1 , 1);
    }
    else
    {
      strcpy_P(filename, PSTR("Rechteck.raw")); 
      myFiles.load(35, 203, 217, 80, filename, 1 , 1);
    }
  }
  if (refresh_ChangeMode)
  {
    refresh_ChangeMode = 0;
    if (state_ChangeMode == 0)
    {
      strcpy_P(filename, PSTR("Dreieck.raw")); 
      myFiles.load(35, 305, 217, 80, filename, 1 , 1);
    }
    else
    {
      strcpy_P(filename, PSTR("Rechteck.raw")); 
      myFiles.load(35, 305, 217, 80, filename, 1 , 1);
    }
  }
  if (refresh_Hertz)
  {
    refresh_Hertz = 0;
    strcpy_P(filename, NamePicHertz[counter_Hertz]);
    myFiles.load(475, 225, 217, 80, filename, 1 , 1);//Startbildschirm
  }
  if (refresh_Power)
  {
    refresh_Power = 0;
    strcpy_P(filename,  NamePicPower[counter_Power]);
    myFiles.load(475, 51, 217, 80, filename, 1 , 1);//Startbildschirm
  }
  if (refresh_StartStop)
  {
    refresh_StartStop = 0;

    if (state_StartStop)
    {
      strcpy_P(filename, PSTR("On.raw")); 
      myFiles.load(35, 15, 217, 80, filename, 1 , 1);//Startbildschirm
    }
    else
    {
      strcpy_P(filename, PSTR("Off.raw")); 
      myFiles.load(35, 15, 217, 80, filename, 1 , 1);//Startbildschirm
    }

    if (counterSekunden < 0)
    {
      counterSekunden = 59;
      counterMinuten--;
    }
    strcpy_P(filename, NameTime[counterSekunden]);
    myFiles.load(410, 390, 80, 80, filename, 1 , 1);//Startbildschirm
    strcpy_P(filename, NameTime[counterMinuten]);
    myFiles.load(275, 390, 80, 80, filename, 1 , 1);//Startbildschirm
  }
}
